#! /bin/sh

# this ugly stuff needs to be replaced by commandline options
USER=ccpsc
SITENAME=drupal
HOST=ccpsc.qc.ca
SUBDIR= # leading slash is critical (or leave empty)
VERSION="5.0"
# db stuff, autogenerated
DB="${USER}_${SITENAME}"
DBUSER=$DB
PASS=`pwgen`

# todo
# - wrong username / db setup in 5.0
# - localhost grant is bad
# - setup install profile in 5.0 so that username/pass is setup properly
# - installer installs to default/settings.php instead of $confname/settings.php
# - files/ must be created in SITES_PATH, and must be set in the file_directory_path variable. files must be root:root 777
sanity_checks() {
    if [ -e $TARGET ]; then
	echo "target directory $TARGET already exists, aborting"
	exit 1
    fi
    if [ -e $SITEPATH ]; then
	echo "target sites path $SITEPATH already exists, aborting"
	exit 2
    fi
    if [ -e sites/$confname ]; then
	echo "$confname already configured, aborting"
	exit 3
    fi
}

print_domain_letter() {
    local domain="$1"

    local letter=`echo "$domain" | awk '{z=split($NF, a, ".") ; print substr(a[z-1], 1, 1)}'`
    if [ -z "$letter" ]; then
      letter="_"
    fi
    echo $letter
}

print_user_letter() {
    local user="$1"

    echo "$user" | awk '{print substr($1, 1, 1)}'
}

# FIXME: those two lines need a correction if we want multiple drupals per host
if [ -z "$SUBDIR" ] || [ "$SUBDIR" = "/" ] ; then
	confname=$HOST
	SUBDIR=""
else
	confname=`echo $HOST$SUBDIR | sed 's#/#.#g'`
fi
TARGET=/var/alternc/dns/`print_domain_letter $HOST`/$HOST$SUBDIR
SITEPATH=/var/alternc/html/`print_user_letter $USER`/$USER/.drupalfarm/$confname

cd /usr/share/drupal/$VERSION/core
sanity_checks
mysql --defaults-file=/etc/mysql/debian.cnf -e "CREATE DATABASE $DB;" # user db
mysql --defaults-file=/etc/mysql/debian.cnf -e "GRANT ALL ON \`$DB\`.* TO \`$DBUSER\`@\`%\` IDENTIFIED BY '$PASS';" # db
if [ "$VERSION" = "4.7" ]; then
	mysql --defaults-file=/etc/mysql/debian.cnf $DB < /usr/share/drupal/$VERSION/core/database/database.4.1.mysql # charger la db drupal
else
	# ??? rien?
	true
fi

mkdir -p $SITEPATH
ln -s $SITEPATH sites/$confname

sed -e "/^\\\$db_url =/{s/username/$DB/;s/password/$PASS/;s/databasename/$DB/}" < sites/default/settings.php >  sites/$confname/settings.php

ln -s /usr/share/drupal/$VERSION/core/ $TARGET

#setup default contribs:
#   for mod in `cat sites/default/defaultmodules` ; do ln -s contrib/modules/$mod core/sites/example.com/modules/
